# Testumgebung
Für die Testumgebung existiert eine separate Konfiguration (`src/test/resources/application.properties`), in der eine H2 In-Memory Datenbank verwendet wird. Bei Start der Integration Tests wird eine Verbindung zu der Datenbank aufgebaut, wodurch alle Repositories die Daten daraus ziehen. Repositories/Services sind im Fall von Unit-Tests zu mocken, wenn nötig. 

:::caution VPN
Einige Integration Tests hängen von externen Systemen (z.B. GitLab oder [Eva](/eva)) ab. Diese Systeme befinden sich teilweise in der Testumgebung, wodurch die Tests ggf. nur über ein VPN ausgeführt werden können
:::

:::caution Zugangsdaten
Einige Tests erfordern die Konfiguration von Zugangsdaten vor Ausführung. Betroffen ist:

- [Git-Synchronisation von Aufgaben-Pools](../config.md#git-synchronisation-von-aufgaben-pools)
:::

## Fixtures
In den Tests werden Fixtures verwendet, die nachfolgend erklärt werden. Diese werden in `src/test/resources/data.sql` initialisiert. Die SQL-Datei wird zu Beginn der Tests für die Initialisierung 
der Datenbank geladen. Soll die Datenbank bei jedem Test neu initialisiert werden, ist die Testklasse wie folgt zu annotieren:

```
@DirtiesContext(classMode = DirtiesContext.ClassMode.BEFORE_EACH_TEST_METHOD)
@AutoConfigureTestDatabase(replace = AutoConfigureTestDatabase.Replace.ANY)
```

## Authentifizierung mocken
Mit der Annotation `@WithUserDetails("US_C1A")` werden (wenn `MockMvc` verwendet wird) die HTTP Requests in Integration Tests
so simuliert, dass diese vom Benutzer mit dem angegebenen Benutzernamen (hier: `US_C1A`) kommen. 

Die Benutzer sind in `data.sql` anzulegen, das Benennungsschema ergibt sich aus:

- `U`: Steht für Benutzer
- `S`: Steht für die Rolle `staff`
- `C1A`: Steht dafür, dass der Benutzer im Kurs 1 die `Admin`-Berechtigung hat.

Die Benutzer sollten nach Möglichkeit wiederverwendet werden, damit die Testsuite wartbar bleibt.
