# Caching
Ab und an kommt es vor, dass auf einer Seite mehrere Komponenten eingebunden werden, die die selben Daten vom Backend benötigen und bei Initialisierung einen HTTP Request stellen. Die Daten werden nicht von der übergeordneten Komponente (der Seite) geladen um das Single-Responsibility Prinzip zu wahren und somit den Code zu vereinfachen. Dabei entstehen aber doppelte HTTP Requests, die vermieden werden sollten.   

Im Frontend wird deshalb partiell gecacht. Dafür wird [cashew](https://github.com/ngneat/cashew) eingesetzt und in `app.module.ts` konfiguriert. Die aktuelle Konfiguration sieht vor, dass jeder HTTP Request durch `cashew` geht - Responses werden aber nicht gespeichert. `cashew` sorgt dafür, dass mehrere parallel gestartete Requests zu einem Request zusammengefasst werden.

:::note
Caching mit einer TTL > 0 wird im Frontend bewusst vermieden, da die Invalidierung nicht trivial ist. Es wurde früher mal eingesetzt, hat jedoch zu inkonsistenten Zuständen geführt, die ein neu laden der Anwendung mit F5 erfordert haben. 

Zukünftig kann aber überlegt werden, ob bestimmte Daten (Dateien zu Lösungen/Aufgaben) im Frontend gecached werden, wenn es dahingehend Optimierungsbedarf gibt.
:::