import { NgModule } from '@angular/core';
import { Routes, RouterModule, ActivatedRouteSnapshot } from '@angular/router';
import { CourseUnit } from '../courses/models/course-unit';
import { CourseResultsComponent } from './pages/course-results/course-results.component';
import { CourseUnitProgressComponent } from './pages/course-unit-progress/course-unit-progress.component';
import { ParticipantProgressComponent } from './pages/participant-progress/participant-progress.component';

export const routes: Routes = [
  {
    path: 'course/:course_id/progress',
    component: ParticipantProgressComponent,
    data: {
      reuseRoute: true,
      courseMenuEnabled: true
    }
  },
  {
    path: 'course/:course_id/progress/:user_id',
    component: ParticipantProgressComponent,
    data: {
      reuseRoute: true,
      courseMenuEnabled: true
    }
  },
  {
    path: 'course/:course_id/results',
    component: CourseResultsComponent,
    data: {
      reuseRoute: true,
      breadcrumb: {
        alias: 'courseResults',
        label: 'Kursergebnisse'
      },
      courseMenuEnabled: true
    }
  },
  {
    path: 'course/:course_id/results/:unit_id',
    component: CourseUnitProgressComponent,
    data: {
      reuseRoute: true,
      breadcrumb: {
        alias: 'courseUnitProgress',
        label: (unit: CourseUnit) => unit.shortName 
      },
      courseMenuEnabled: true
    }
  }
];

@NgModule({
  exports: [RouterModule]
})
export class ProgressRoutingModule { }
