import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { CourseUnitProgressComponent } from './pages/course-unit-progress/course-unit-progress.component';
import { ParticipantProgressComponent } from './pages/participant-progress/participant-progress.component';
import { CoursesModule } from '../courses/courses.module';
import { ExercisesModule } from '../exercises/exercises.module';
import { AttendancesModule } from '../attendances/attendances.module';
import { SharedModule } from 'app/shared/shared.module';
import { ProgressRoutingModule } from './progress-routing.module';
import { CourseUnitParticipantSelectionComponent } from './components/course-unit-participant-selection/course-unit-participant-selection.component';
import { CourseResultsComponent } from './pages/course-results/course-results.component';

@NgModule({
  declarations: [
    CourseUnitParticipantSelectionComponent,
    CourseResultsComponent,
    CourseUnitProgressComponent,
    ParticipantProgressComponent,
  ],
  imports: [
    CommonModule,
    SharedModule,
    ProgressRoutingModule,
    CoursesModule,
    ExercisesModule,
    AttendancesModule
  ]
})
export class ProgressModule { }
