import { Injectable, ViewContainerRef } from "@angular/core";
import { Solution } from "app/features/solutions/models/solution";
import { BaseComponent } from "app/shared/components/base/base.component";
import { FileTree } from "app/shared/models/file-tree";
import { Observable, of } from "rxjs";
import { NothingViewerComponent } from "./nothing-viewer.component";

@Injectable({
    providedIn: 'root'
})
export class NothingViewerFactory extends BaseComponent {
    constructor() {
        super();
    }

    createViewer(containerRef: ViewContainerRef): Observable<void> {
        containerRef.createComponent<NothingViewerComponent>(NothingViewerComponent);
        return of(null);
    }
}