import { NgModule } from '@angular/core';
import { Routes, RouterModule, ActivatedRouteSnapshot } from '@angular/router';
import { Solution } from './models/solution';
import { SolutionComponent } from './pages/solution/solution.component';


export const routes: Routes = [
  {
    path: 'solutions/:solution_id',
    component: SolutionComponent,
    data: {
      breadcrumb: {
        alias: 'solutions',
        label: (solution: Solution) => `Lösung ${solution.id}` 
      },
      courseMenuEnabled: true
    }
  }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class SolutionsRoutingModule { }
