import { Component, Input, OnInit, TemplateRef } from '@angular/core';
import { AppStateService } from 'app/core/services/app.state.service';
import { Task } from 'app/features/tasks/models/task';
import { BaseComponent } from 'app/shared/components/base/base.component';
import { DownloadService } from 'app/shared/services/download.service';
import { forkJoin, Observable, of } from 'rxjs';
import { map, takeUntil, tap } from "rxjs/operators";

@Component({
  selector: 'ngx-task-summary',
  templateUrl: './task-summary.component.html',
  styleUrls: ['./task-summary.component.scss']
})
export class TaskSummaryComponent extends BaseComponent implements OnInit {
  @Input() task: Task;
  @Input() content: string;
  
  @Input() expandable: boolean = false;

  @Input()
  tagsTpl: TemplateRef<any>;
  darkMode: boolean = false;

  constructor(private appStateService: AppStateService) {
    super();
  }

  ngOnInit(): void {
    this.appStateService.darkMode$
    .pipe(takeUntil(this.unsubscribe))
    .subscribe(darkMode => this.darkMode = darkMode);
  }
}
  
