package de.hsrm.sls.subato.auth.masking;

import com.fasterxml.jackson.databind.util.StdConverter;
import de.hsrm.sls.subato.auth.Role;
import de.hsrm.sls.subato.auth.principal.PrincipalService;
import de.hsrm.sls.subato.tasks.task.TaskDto;
import org.springframework.beans.factory.annotation.Autowired;

public class TaskMasker extends StdConverter<TaskDto, TaskDto> {
    @Autowired
    PrincipalService principalService;

    @Override
    public TaskDto convert(TaskDto value) {
        var principal = principalService.getPrincipal();
        if(principal == null || !principal.hasAnyRole(Role.Staff, Role.SuperAdmin)) {
            value.setEvaluator(null);
            value.setPool(null);
            value.setFeedbackStats(null);
            value.setRepositoryUrl(null);
        }
        return value;
    }
}
