package de.hsrm.sls.subato.auth.policy.tasks;

import de.hsrm.sls.subato.auth.Role;
import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to update languages
 */
@Component
public class LanguageUpdatePolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(TasksAction.LANGUAGE_UPDATE) || request.unauthenticated()) {
            return false;
        }

        return request.getSubject().hasRole(Role.SuperAdmin);
    }
}
