package de.hsrm.sls.subato.courses.course;

import de.hsrm.sls.subato.exercises.submission.Submission;
import de.hsrm.sls.subato.modules.term.Term;
import de.hsrm.sls.subato.user.User;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Optional;

public interface CourseRepository extends JpaRepository<Course, Long>, JpaSpecificationExecutor<Course> {
    @Query("select c from Course c where c.term.id = ?1")
    List<Course> findByTermId(long id);
    boolean existsBySourceId(Long sourceId);
    Optional<Course> findBySourceId(long sourceId);
}
