package de.hsrm.sls.subato.courses.unit;

import de.hsrm.sls.subato.courses.course.Course;
import de.hsrm.sls.subato.user.User;

import java.util.ArrayList;
import java.util.List;

public class CreateCourseUnitRequestBuilder {
    private Course course;
    private String name;
    private CourseUnitType type;
    private Long aorId;
    private List<User> participants = new ArrayList<>();
    private List<User> lecturers = new ArrayList<>();

    public CreateCourseUnitRequestBuilder setCourse(Course course) {
        this.course = course;
        return this;
    }

    public CreateCourseUnitRequestBuilder setName(String name) {
        this.name = name;
        return this;
    }

    public CreateCourseUnitRequestBuilder setType(CourseUnitType type) {
        this.type = type;
        return this;
    }

    public CreateCourseUnitRequestBuilder setAorId(Long aorId) {
        this.aorId = aorId;
        return this;
    }

    public CreateCourseUnitRequestBuilder setParticipants(List<User> participants) {
        this.participants = participants;
        return this;
    }

    public CreateCourseUnitRequestBuilder setLecturers(List<User> lecturers) {
        this.lecturers = lecturers;
        return this;
    }

    public CreateCourseUnitRequest build() {
        return new CreateCourseUnitRequest(course, name, type, aorId, participants, lecturers);
    }
}