package de.hsrm.sls.subato.exercises.taskinstance;

import de.hsrm.sls.subato.exercises.exercise.Exercise;
import de.hsrm.sls.subato.exercises.submission.SubmissionPointRating;
import de.hsrm.sls.subato.tasks.task.Task;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "task_instance", uniqueConstraints={
    @UniqueConstraint(columnNames = {"exercise_id", "task_id"})
})
public class TaskInstance {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @ManyToOne
    private Exercise exercise;

    @ManyToOne
    private Task task;

    private Integer reachablePoints;

    @OneToMany(mappedBy = "taskInstance", cascade = CascadeType.REMOVE)
    private List<SubmissionPointRating> pointRatings = new ArrayList<>();

    private int orderNumber;

    private boolean solutionPublic;

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Exercise getExercise() {
        return exercise;
    }

    public void setExercise(Exercise exercise) {
        this.exercise = exercise;
    }

    public Task getTask() {
        return task;
    }

    public void setTask(Task task) {
        this.task = task;
    }

    public boolean isSolutionPublic() {
        return solutionPublic;
    }

    public void setSolutionPublic(boolean solutionPublic) {
        this.solutionPublic = solutionPublic;
    }

    public int getOrderNumber() {
        return orderNumber;
    }

    public void setOrderNumber(int order) {
        this.orderNumber = order;
    }

    public Integer getReachablePoints() {
        return reachablePoints;
    }

    public void setReachablePoints(Integer reachablePoints) {
        this.reachablePoints = reachablePoints;
    }

    public List<SubmissionPointRating> getPointRatings() {
        return pointRatings;
    }

    public void setPointRatings(List<SubmissionPointRating> pointRatings) {
        this.pointRatings = pointRatings;
    }
}
