package de.hsrm.sls.subato.tasks.stef.parser.meta;

import de.hsrm.sls.subato.solutions.evaluation.evaluator.Evaluator;
import de.hsrm.sls.subato.solutions.evaluation.evaluator.EvaluatorNotFoundException;
import de.hsrm.sls.subato.solutions.evaluation.evaluator.EvaluatorService;
import de.hsrm.sls.subato.tasks.stef.Meta;
import de.hsrm.sls.subato.tasks.stef.parser.InvalidSpecException;
import de.hsrm.sls.subato.tasks.stef.parser.meta.xml.TaskXml;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class EvaluatorExtractor {
    @Autowired
    private EvaluatorService evaluatorService;

    public void extract(TaskXml doc, Meta meta) {
        Evaluator evaluator = null;

        if(doc.getEvaluator() != null && !doc.getEvaluator().equals("unknown")) {
            try {
                evaluator = evaluatorService.resolveReference(doc.getEvaluator());
            } catch(EvaluatorNotFoundException ex) {
                throw new InvalidSpecException("Es wurde kein passender Evaluator für %s im System gefunden".formatted(doc.getEvaluator()));
            }
        }

        meta.setEvaluator(evaluator != null ? evaluator.getEid() : null);
    }
}
